#!/usr/bin/perl 

package KShieldAuthDB ;
use Kernel::System::Auth::DB ;
@ISA = qw (Kernel::System::Auth::DB) ;

use KShieldClient ;

sub new {
	my($class) = shift;
  my(%params) = @_;
  my($Self) = Kernel::System::Auth::DB->new(@_);
	
  
  $Self->{serverURL} = $Self->{ConfigObject}->Get( 'AuthModule::KShield::ServerURL' . $Param{Count} );
  $Self->{APIKey} = $Self->{ConfigObject}->Get( 'AuthModule::KShield::APIKey' . $Param{Count} );
  $Self->{kshieldUserAttr} = $Self->{ConfigObject}->Get( 'AuthModule::KShield::UserAttr' . $Param{Count} );
	
  return (bless($Self, $class));
}

sub ObtainKShieldUID {
	my($Self) = @_ ;
	
	$wst = new KShieldClient($Self->{serverURL}, $Self->{APIKey}, $Self->{kshieldUserAttr}) ;
	
	my $RemoteAddr = $ENV{REMOTE_ADDR} ;
	
	return $wst->getByIP($RemoteAddr) ;
}

sub GetOption {
  my ($Self, %Param) = @_ ;
	
	my $uid = $Self->ObtainKShieldUID ;
	
  my $fdn =  $uid -> {fdn} ;
	
	if ($fdn) {
		my %Option = ( PreAuth => 1, );
		return $Option{ $Param{What} };
	}
	
	return $Self->SUPER::GetOption(%Param) ;
}

sub Auth {
  my ( $Self, %Param ) = @_;

	my $uid = $Self->ObtainKShieldUID ;
	my $fdn = $uid -> {fdn} ;
  my $screenName = $uid -> {screenName} ;
	
	if (!$Param{Pw} && $fdn) {
		return $screenName ;
	}
	
	return $Self->SUPER::Auth(%Param) ;
}

1;