#!/usr/bin/perl


package KShieldClient ;

use LWP::UserAgent ;
use JSON::PP;

sub new {
    my $class = shift ;
    my $self = {
	_url => shift,
	_apiKey => shift,
	_kshieldUserAttr => shift,
	_ua => new LWP::UserAgent 
    };
    
    bless $self, $class ; 
    
    return $self ;
}


# 
# Returns hash populated with fdn, screenName, authType, authenticatedAt
#
sub getByIP {
    my ($self, $ip) = @_ ;
    if ($ip) {
        my $ua = $self->{_ua} ;
        
        my $urlBase = $self->{_url} ;
        my $apiKey = $self->{_apiKey} ;
        my $kshieldUserAttr = $self->{_kshieldUserAttr} ;
        
        my $url = "$urlBase/json/userByIP/$ip?key=$apiKey&attributes=$kshieldUserAttr" ;
        
        my $request = new HTTP::Request("GET", $url) ;        
        
        my $response = $ua->request($request) ;
        
        if ($response->is_success) {
        	my $ret = decode_json ($response->content) ;
        	
        	if (defined $kshieldUserAttr && $kshieldUserAttr ne '') {
        		my $gotAttribs = $ret -> {attributes} ;
        		$ret -> {screenName} = $gotAttribs -> {$kshieldUserAttr} ;
        	}
        	
    	    return $ret ;
        }
        else {
    	    return { response => $response } ;
        }
    
    }
    
    return undef ;
}

1;